## libxmp 4.6.1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.4...3.10)
project(libxmp VERSION 4.6.1 LANGUAGES C)

set(LIBXMP_DEFINES)
set(LIBXMPLITE_DEFINES)
set(LIBXMP_CFLAGS)

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/libxmp-checks.cmake)
include(GNUInstallDirs)

# -fPIC thing
if(NOT WIN32 AND NOT EMSCRIPTEN AND NOT VITA)
    option(LIBXMP_PIC   "Build the static library as position-independent" OFF)
else()
    set(LIBXMP_PIC OFF)
endif()

if(EMSCRIPTEN OR VITA OR PSP)
    set(BUILD_SHARED_DEFAULT OFF)
else()
    set(BUILD_SHARED_DEFAULT ON)
endif()

option(BUILD_STATIC   "Build libXMP static library" ON)
option(BUILD_SHARED   "Build libXMP shared library" ${BUILD_SHARED_DEFAULT})
option(BUILD_LITE     "Build libXMP-lite library" OFF)
if(NOT BUILD_STATIC AND NOT BUILD_SHARED)
    message(FATAL_ERROR "Both static and shared builds got disabled. You must enable at least one of them.")
endif()

option(LIBXMP_DISABLE_DEPACKERS     "Disable archive depackers" OFF)
option(LIBXMP_DISABLE_PROWIZARD     "Disable ProWizard format loaders" OFF)
option(LIBXMP_DISABLE_IT            "Disable IT format in libXMP-lite" OFF)

include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/libxmp-sources.cmake)

if(LIBXMP_DISABLE_DEPACKERS)
    list(APPEND LIBXMP_DEFINES LIBXMP_NO_DEPACKERS)
else()
    list(APPEND LIBXMP_SRC_LIST ${LIBXMP_SRC_LIST_DEPACKERS})
endif()
if(LIBXMP_DISABLE_PROWIZARD)
    list(APPEND LIBXMP_DEFINES LIBXMP_NO_PROWIZARD)
else()
    list(APPEND LIBXMP_SRC_LIST ${LIBXMP_SRC_LIST_PROWIZARD})
endif()

#lite-only defs
list(APPEND LIBXMPLITE_DEFINES LIBXMP_CORE_PLAYER)
if(LIBXMP_DISABLE_IT)
    list(APPEND LIBXMPLITE_DEFINES LIBXMP_CORE_DISABLE_IT)
endif()

if(MSVC)
    list(APPEND LIBXMP_DEFINES _USE_MATH_DEFINES)
    list(APPEND LIBXMPLITE_DEFINES _USE_MATH_DEFINES)
endif()

#for libxmp-lite.pc
set(libxmplite_VERSION ${libxmp_VERSION})


# extract exports:
set(XMP_EXPORTS)
file(STRINGS ${CMAKE_CURRENT_SOURCE_DIR}/libxmp.map _XMP_EXPORTS)
foreach(export_sym ${_XMP_EXPORTS})
  if(export_sym MATCHES "xmp_.*")
    string(REPLACE ";" "" export_sym ${export_sym})
    string(STRIP ${export_sym} export_sym)
    list(APPEND XMP_EXPORTS "${export_sym}")
  endif()
endforeach()
set(_XMP_EXPORTS)
list(REMOVE_DUPLICATES XMP_EXPORTS)


set(XMP_INSTALLS)

if(BUILD_STATIC)
    add_library(xmp_static STATIC ${LIBXMP_SRC_LIST})
    add_library(libxmp::xmp_static ALIAS xmp_static)
    list(APPEND XMP_INSTALLS xmp_static)
    set_target_properties(xmp_static PROPERTIES C_STANDARD 90)
    if(MSVC)
        set_target_properties(xmp_static PROPERTIES OUTPUT_NAME libxmp-static)
    else()
        set_target_properties(xmp_static PROPERTIES OUTPUT_NAME xmp)
    endif()

    target_compile_options(xmp_static PRIVATE ${LIBXMP_CFLAGS})
    target_compile_definitions(xmp_static PRIVATE ${LIBXMP_DEFINES})
    target_compile_definitions(xmp_static PUBLIC LIBXMP_STATIC)

    if(LIBXMP_PIC)
        target_compile_options(xmp_static PRIVATE -fPIC)
    endif()

    target_include_directories(xmp_static PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>")
    target_include_directories(xmp_static PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")

    if(LIBM_REQUIRED)
        target_link_libraries(xmp_static PUBLIC ${LIBM_LIBRARY})
    endif()

    if(BUILD_LITE)
        add_library(xmp_lite_static STATIC ${LIBXMP_SRC_LIST_LITE})
        add_library(libxmp-lite::xmp_lite_static ALIAS xmp_lite_static)
        list(APPEND XMP_INSTALLS xmp_lite_static)
        set_target_properties(xmp_lite_static PROPERTIES C_STANDARD 90)
        if(MSVC)
            set_target_properties(xmp_lite_static PROPERTIES OUTPUT_NAME libxmp-lite-static)
        else()
            set_target_properties(xmp_lite_static PROPERTIES OUTPUT_NAME xmp-lite)
        endif()

        target_compile_options(xmp_lite_static PRIVATE ${LIBXMP_CFLAGS})
        target_compile_definitions(xmp_lite_static PRIVATE ${LIBXMPLITE_DEFINES})
        target_compile_definitions(xmp_lite_static PUBLIC LIBXMP_STATIC)

        if(LIBXMP_PIC)
            target_compile_options(xmp_lite_static PRIVATE -fPIC)
        endif()

        target_include_directories(xmp_lite_static PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>")
        target_include_directories(xmp_lite_static PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/libxmp-lite>")

        if(LIBM_REQUIRED)
            target_link_libraries(xmp_lite_static PUBLIC ${LIBM_LIBRARY})
        endif()
    endif()
endif()

if(BUILD_SHARED)
    add_library(xmp_shared SHARED ${LIBXMP_SRC_LIST})
    add_library(libxmp::xmp_shared ALIAS xmp_shared)
    list(APPEND XMP_INSTALLS xmp_shared)
    set_target_properties(xmp_shared PROPERTIES C_STANDARD 90)
    if(MSVC)
        set_target_properties(xmp_shared PROPERTIES OUTPUT_NAME libxmp)
    elseif(OS2)
        set_target_properties(xmp_shared PROPERTIES OUTPUT_NAME libxmp)
        set(DEF_CONTENTS "LIBRARY LIBXMP INITINSTANCE TERMINSTANCE\n")
        list(APPEND DEF_CONTENTS "DATA MULTIPLE NONSHARED\n")
        list(APPEND DEF_CONTENTS "EXPORTS\n")
        foreach(export_sym ${XMP_EXPORTS})
            list(APPEND DEF_CONTENTS "    ${export_sym}\n")
        endforeach()
        file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/os2dll.def ${DEF_CONTENTS})
        target_sources(xmp_shared PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/os2dll.def)
    else()
        set_target_properties(xmp_shared PROPERTIES OUTPUT_NAME xmp)
    endif()

    if(HAVE_GCC OR HAVE_CLANG)
        if(APPLE)
            set_property(TARGET xmp_shared APPEND_STRING PROPERTY
                         LINK_FLAGS " -Wl,-undefined,error")
        elseif(NOT CMAKE_SYSTEM_NAME MATCHES "kOpenBSD.*|OpenBSD.*")
            cmake_push_check_state()
            set(CMAKE_REQUIRED_FLAGS "-Wl,--no-undefined")
            check_c_compiler_flag("" HAVE_NO_UNDEFINED)
            cmake_pop_check_state()
            if(HAVE_NO_UNDEFINED)
                set_property(TARGET xmp_shared APPEND_STRING PROPERTY
                             LINK_FLAGS " -Wl,--no-undefined")
            endif()
        endif()
    endif()

    if(HAVE_VISIBILITY AND HAVE_GNU_LD AND UNIX)
        target_compile_definitions(xmp_shared PRIVATE USE_VERSIONED_SYMBOLS=1)
        set_property(TARGET xmp_shared APPEND_STRING PROPERTY
                     LINK_FLAGS " -Wl,--version-script,\"${CMAKE_CURRENT_SOURCE_DIR}/libxmp.map\"")
        message(STATUS "Versioned symbols: ENABLED.")
    else()
        message(STATUS "Versioned symbols: DISABLED")
    endif()

    target_compile_options(xmp_shared PRIVATE ${LIBXMP_CFLAGS})
    target_compile_definitions(xmp_shared PRIVATE ${LIBXMP_DEFINES})
    if(WIN32)
        target_compile_definitions(xmp_shared PRIVATE BUILDING_DLL)
    endif()

    target_include_directories(xmp_shared PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>")
    target_include_directories(xmp_shared PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}>")

    set_target_properties(xmp_shared PROPERTIES VERSION ${libxmp_VERSION} SOVERSION ${libxmp_VERSION_MAJOR})

    if(ANDROID AND CMAKE_BUILD_TYPE_LOWER STREQUAL "debug")
        target_link_libraries(xmp_shared PRIVATE log)
    endif()
    if(LIBM_REQUIRED)
        target_link_libraries(xmp_shared PUBLIC ${LIBM_LIBRARY})
    endif()

    if(BUILD_LITE)
        add_library(xmp_lite_shared SHARED ${LIBXMP_SRC_LIST_LITE})
        add_library(libxmp-lite::xmp_lite_shared ALIAS xmp_lite_shared)
        list(APPEND XMP_INSTALLS xmp_lite_shared)
        set_target_properties(xmp_lite_shared PROPERTIES C_STANDARD 90)
        if(MSVC)
            set_target_properties(xmp_lite_shared PROPERTIES OUTPUT_NAME libxmp-lite)
        elseif(OS2)
            set_target_properties(xmp_lite_shared PROPERTIES OUTPUT_NAME libxmplt)
            set(DEF_CONTENTS "LIBRARY LIBXMPLT INITINSTANCE TERMINSTANCE\n")
            list(APPEND DEF_CONTENTS "DATA MULTIPLE NONSHARED\n")
            list(APPEND DEF_CONTENTS "EXPORTS\n")
            foreach(export_sym ${XMP_EXPORTS})
                list(APPEND DEF_CONTENTS "    ${export_sym}\n")
            endforeach()
            file(WRITE ${CMAKE_CURRENT_BINARY_DIR}/os2lite.def ${DEF_CONTENTS})
            target_sources(xmp_lite_shared PRIVATE ${CMAKE_CURRENT_BINARY_DIR}/os2lite.def)
        else()
            set_target_properties(xmp_lite_shared PROPERTIES OUTPUT_NAME xmp-lite)
        endif()

        if(HAVE_GCC OR HAVE_CLANG)
            if(APPLE)
                set_property(TARGET xmp_lite_shared APPEND_STRING PROPERTY
                             LINK_FLAGS " -Wl,-undefined,error")
            elseif(NOT CMAKE_SYSTEM_NAME MATCHES "kOpenBSD.*|OpenBSD.*")
                cmake_push_check_state()
                set(CMAKE_REQUIRED_FLAGS "-Wl,--no-undefined")
                check_c_compiler_flag("" HAVE_NO_UNDEFINED)
                cmake_pop_check_state()
                if(HAVE_NO_UNDEFINED)
                    set_property(TARGET xmp_lite_shared APPEND_STRING PROPERTY
                                 LINK_FLAGS " -Wl,--no-undefined")
                endif()
            endif()
        endif()

        if(HAVE_VISIBILITY AND HAVE_GNU_LD AND UNIX)
            target_compile_definitions(xmp_lite_shared PRIVATE USE_VERSIONED_SYMBOLS=1)
            set_property(TARGET xmp_lite_shared APPEND_STRING PROPERTY
                         LINK_FLAGS " -Wl,--version-script,${CMAKE_CURRENT_SOURCE_DIR}/libxmp.map")
        endif()

        target_compile_options(xmp_lite_shared PRIVATE ${LIBXMP_CFLAGS})
        target_compile_definitions(xmp_lite_shared PRIVATE ${LIBXMPLITE_DEFINES})
        if(WIN32)
            target_compile_definitions(xmp_lite_shared PRIVATE BUILDING_DLL)
        endif()

        target_include_directories(xmp_lite_shared PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>")
        target_include_directories(xmp_lite_shared PUBLIC "$<INSTALL_INTERFACE:${CMAKE_INSTALL_INCLUDEDIR}/libxmp-lite>")

        set_target_properties(xmp_lite_shared PROPERTIES VERSION ${libxmp_VERSION} SOVERSION ${libxmp_VERSION_MAJOR})

        if(ANDROID AND CMAKE_BUILD_TYPE_LOWER STREQUAL "debug")
            target_link_libraries(xmp_lite_shared PRIVATE log)
        endif()
        if(LIBM_REQUIRED)
            target_link_libraries(xmp_lite_shared PUBLIC ${LIBM_LIBRARY})
        endif()
    endif()
endif()


add_library(XMP_IF INTERFACE)
if(NOT BUILD_SHARED)
    target_link_libraries(XMP_IF INTERFACE xmp_static)
else()
    target_link_libraries(XMP_IF INTERFACE xmp_shared)
endif()

if(BUILD_LITE)
    add_library(XMPLITE_IF INTERFACE)
    if(NOT BUILD_SHARED)
        target_link_libraries(XMPLITE_IF INTERFACE xmp_lite_static)
    else()
        target_link_libraries(XMPLITE_IF INTERFACE xmp_lite_shared)
    endif()
endif()

# === Unit tests ====
option(WITH_UNIT_TESTS "Enable unit testing" OFF)
if(WITH_UNIT_TESTS)
    enable_testing()
    add_subdirectory(test)
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/test-dev/")
        add_subdirectory(test-dev)
    endif()
endif()

if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/examples/CMakeLists.txt")
    add_subdirectory(examples)
endif()


# === Documentation ====
add_subdirectory(docs)


# === Install ====

include(CMakePackageConfigHelpers)

if(WIN32)
    set(cmake_install_cmakdir "cmake")
    set(cmake_install_cmakdir_lite "cmake")
else()
    set(cmake_install_cmakdir "${CMAKE_INSTALL_LIBDIR}/cmake/libxmp")
    set(cmake_install_cmakdir_lite "${CMAKE_INSTALL_LIBDIR}/cmake/libxmp-lite")
endif()

set(prefix ${CMAKE_INSTALL_PREFIX})
set(exec_prefix "\${prefix}")
set(includedir "${CMAKE_INSTALL_FULL_INCLUDEDIR}")
set(libdir     "${CMAKE_INSTALL_FULL_LIBDIR}")
set(bindir     "${CMAKE_INSTALL_FULL_BINDIR}")
configure_file("${CMAKE_CURRENT_SOURCE_DIR}/libxmp.pc.in"
               "${CMAKE_CURRENT_BINARY_DIR}/libxmp.pc" @ONLY
)
write_basic_package_version_file(libxmp-config-version.cmake
    COMPATIBILITY AnyNewerVersion
)
if(TARGET xmp_shared)
    install(TARGETS xmp_shared EXPORT libxmp_shared_exports

=== debian/changelog ===
libxmp (4.6.1-2) unstable; urgency=medium

  * Add missing build dependency on rst2pdf. Thanks to Gui-Yue for
    noticing the problem! Closes: #1092197.

 -- Stephen Kitt <skitt@debian.org>  Mon, 06 Jan 2025 06:47:30 +0100

libxmp (4.6.1-1) unstable; urgency=medium

  * New upstream release.
  * Relicense the Debian packaging to match upstream.
  * Include the documentation in the build, and remove the Google fonts
    import to avoid network access.

 -- Stephen Kitt <skitt@debian.org>  Sun, 05 Jan 2025 17:11:39 +0100

=== debian/control ===
Source: libxmp
Section: libs
Priority: optional
Maintainer: Stephen Kitt <skitt@debian.org>
Standards-Version: 4.7.0
Build-Depends: debhelper-compat (= 13), python3-docutils, rst2pdf
Homepage: http://xmp.sourceforge.net/
Vcs-Git: https://salsa.debian.org/mod-player-team/libxmp.git
Vcs-Browser: https://salsa.debian.org/mod-player-team/libxmp
Rules-Requires-Root: no

Package: libxmp4
Architecture: any
Multi-Arch: same
Pre-Depends: ${misc:Pre-Depends}
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: module file rendering library
 libxmp is a library designed to interpret module files and produce
 PCM audio. It supports over 90 formats including Protracker (MOD),
 Scream Tracker 3 (S3M), Fast Tracker II (XM) and Impulse Tracker
 (IT).

Package: libxmp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends}, libxmp4 (= ${binary:Version})
Description: module file rendering library -- development files
 libxmp is a library designed to interpret module files and produce
 PCM audio. It supports over 90 formats including Protracker (MOD),
 Scream Tracker 3 (S3M), Fast Tracker II (XM) and Impulse Tracker
 (IT).
 .
 This package contains the development files required to build with
 libxmp.

## libxmp 4.6.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.4...3.10)
-project(libxmp VERSION 4.6.1 LANGUAGES C)
+project(libxmp VERSION 4.6.2 LANGUAGES C)
 
 set(LIBXMP_DEFINES)
 set(LIBXMPLITE_DEFINES)

=== test/Makefile ===

TEST_OBJS	= test.o
TESTLITE_OBJS	= testlite.o
TEST_DFILES	= Makefile CMakeLists.txt $(TEST_OBJS:.o=.c) $(TESTLITE_OBJS:.o=.c) test.it test.itz test.xm
TEST_PATH	= test

MAIN_OBJS	= md5.o
MAIN_PATH	= src

T_OBJS = $(addprefix $(TEST_PATH)/,$(TEST_OBJS))
T_OBJS += $(addprefix $(MAIN_PATH)/,$(MAIN_OBJS))
TLITE_OBJS = $(addprefix $(TEST_PATH)/,$(TESTLITE_OBJS))
TLITE_OBJS += $(addprefix $(MAIN_PATH)/,$(MAIN_OBJS))

default:
	$(MAKE) -C .. check

dist-test:
	mkdir -p $(DIST)/$(TEST_PATH)
	cp -RPp $(addprefix $(TEST_PATH)/,$(TEST_DFILES)) $(DIST)/$(TEST_PATH)

check: $(TEST_PATH)/libxmp-test
	cd $(TEST_PATH); LD_LIBRARY_PATH=../lib DYLD_LIBRARY_PATH=../lib LIBRARY_PATH=../lib:$$LIBRARY_PATH PATH=$$PATH:../lib ./libxmp-test

$(TEST_PATH)/libxmp-test: $(T_OBJS)
	@CMD='$(LD) $(LDFLAGS) -o $@ $(T_OBJS) $(LIBS) -Llib -lxmp'; \
	if [ "$(V)" -gt 0 ]; then echo $$CMD; else echo LD $@ ; fi; \
	eval $$CMD

check-lite: $(TEST_PATH)/libxmp-lite-test
	cd $(TEST_PATH); LD_LIBRARY_PATH=../lib DYLD_LIBRARY_PATH=../lib LIBRARY_PATH=../lib:$$LIBRARY_PATH PATH=$$PATH:../lib ./libxmp-lite-test

$(TEST_PATH)/libxmp-lite-test: $(TLITE_OBJS)
	@CMD='$(LD) -o $@ $(TLITE_OBJS) $(LIBS) -Llib -lxmp-lite'; \
	if [ "$(V)" -gt 0 ]; then echo $$CMD; else echo LD $@ ; fi; \
	eval $$CMD

=== debian/changelog ===
libxmp (4.6.2-2) unstable; urgency=medium

  * Apply upstream fix for CVE-2025-47256.

 -- Stephen Kitt <skitt@debian.org>  Wed, 07 May 2025 08:44:26 +0200

libxmp (4.6.2-1) unstable; urgency=medium

  * New upstream release.
  * Standards-Version 4.7.2, no change required.

 -- Stephen Kitt <skitt@debian.org>  Sun, 02 Mar 2025 21:06:42 +0100

## libxmp 4.6.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
 cmake_minimum_required(VERSION 3.4...3.10)
-project(libxmp VERSION 4.6.2 LANGUAGES C)
+project(libxmp VERSION 4.6.3 LANGUAGES C)
 
 set(LIBXMP_DEFINES)
 set(LIBXMPLITE_DEFINES)
@@ -54,6 +54,9 @@
 if(MSVC)
     list(APPEND LIBXMP_DEFINES _USE_MATH_DEFINES)
     list(APPEND LIBXMPLITE_DEFINES _USE_MATH_DEFINES)
+else()
+    list(APPEND LIBXMP_DEFINES _REENTRANT)
+    list(APPEND LIBXMPLITE_DEFINES _REENTRANT)
 endif()
 
 #for libxmp-lite.pc
@@ -316,5 +319,3 @@
 write_basic_package_version_file(libxmp-config-version.cmake
     COMPATIBILITY AnyNewerVersion
 )
-if(TARGET xmp_shared)
-    install(TARGETS xmp_shared EXPORT libxmp_shared_exports

=== docs/CMakeLists.txt ===
option(LIBXMP_DOCS "Build the library documentation" ON)

set(libxmp_man_rst ${CMAKE_CURRENT_SOURCE_DIR}/manpage.rst)
set(libxmp_html_rst ${CMAKE_CURRENT_SOURCE_DIR}/pdfdoc.rst)
set(libxmp_man ${CMAKE_CURRENT_BINARY_DIR}/libxmp.3)
set(libxmp_html ${CMAKE_CURRENT_BINARY_DIR}/libxmp.html)
set(libxmp_pdf ${CMAKE_CURRENT_BINARY_DIR}/libxmp.pdf)

if(LIBXMP_DOCS)
  find_program(RST2MAN_EXE rst2man)
  find_program(RST2HTML_EXE rst2html)
  find_program(RST2PDF_EXE rst2pdf)

  if(NOT RST2MAN_EXE)
    message(STATUS "Manpage generation disabled: rst2man not found")
  else()
    message(STATUS "Found ${RST2MAN_EXE}")
    add_custom_command(OUTPUT ${libxmp_man}
      COMMAND ${RST2MAN_EXE} ${libxmp_man_rst} ${libxmp_man}
      DEPENDS ${libxmp_rst}
      COMMENT "Creating Info file ${libxmp_man}"
      VERBATIM)
    add_custom_target(libxmp_gen_man ALL DEPENDS ${libxmp_man})
    if(UNIX OR MINGW OR CYGWIN)
      include(GNUInstallDirs)
      install(FILES "${libxmp_man}"
              DESTINATION ${CMAKE_INSTALL_MANDIR}/man3
      )
    endif()
  endif()

  if(NOT RST2HTML_EXE)
    message(STATUS "HTML doc generation disabled: rst2html not found")
  else()
    message(STATUS "Found ${RST2HTML_EXE}")
    add_custom_command(OUTPUT ${libxmp_html}
      COMMAND ${RST2HTML_EXE} --stylesheet ${CMAKE_CURRENT_SOURCE_DIR}/style.css ${libxmp_html_rst} ${libxmp_html}
      DEPENDS ${libxmp_html_rst}
      COMMENT "Creating HTML file ${libxmp_html}"
      VERBATIM)
    add_custom_target(libxmp_gen_html ALL DEPENDS ${libxmp_html})
  endif()

  if(NOT RST2PDF_EXE)
    message(STATUS "PDF doc generation disabled: rst2pdf not found")
  else()
    message(STATUS "Found ${RST2PDF_EXE}")
    add_custom_command(OUTPUT ${libxmp_pdf}
      COMMAND ${RST2PDF_EXE} -c --smart-quotes=1 -s ${CMAKE_CURRENT_SOURCE_DIR}/custom.style --footer=\#\#\#Page\#\#\# ${libxmp_html_rst} -o ${libxmp_pdf}
      DEPENDS ${libxmp_html_rst}
      COMMENT "Creating HTML file ${libxmp_pdf}"
      VERBATIM)
    add_custom_target(libxmp_gen_pdf ALL DEPENDS ${libxmp_pdf})
  endif()
endif()

=== docs/Makefile ===

DOCS_DFILES	= Makefile CMakeLists.txt           \
		  COPYING CREDITS Changelog         \
		  formats.txt fixloop.txt           \
		  libxmp.rst manpage.rst pdfdoc.rst \
		  custom.style style.css $(DOCS_FILES)

DOCS_PATH	= docs

DOCS_FILES	= libxmp.html libxmp.3 libxmp.pdf

DOCS += $(addprefix $(DOCS_PATH)/,$(DOCS_FILES))

all-docs: $(DOCS)

$(DOCS): docs/Makefile

install-docs: $(DOCS)
	@echo "Installing manpages in $(DESTDIR)$(MANDIR)"
	@[ -d $(DESTDIR)$(MANDIR) ] || mkdir -p $(DESTDIR)$(MANDIR)
	@$(INSTALL_DATA) docs/libxmp.3 $(DESTDIR)$(MANDIR)

dist-docs:
	mkdir -p $(DIST)/$(DOCS_PATH)
	cp -RPp $(addprefix $(DOCS_PATH)/,$(DOCS_DFILES)) $(DIST)/$(DOCS_PATH)

docs/libxmp.3: docs/libxmp.rst docs/manpage.rst
	rst2man docs/manpage.rst > $@

docs/libxmp.html: docs/libxmp.rst docs/pdfdoc.rst docs/style.css
	rst2html docs/pdfdoc.rst --stylesheet docs/style.css > $@

docs/libxmp.pdf: docs/libxmp.rst docs/pdfdoc.rst docs/custom.style
	rst2pdf docs/pdfdoc.rst -c --smart-quotes=1 -s docs/custom.style --footer="###Page###" -o $@

=== src/Makefile ===

SRC_OBJS	= virtual.o format.o period.o player.o read_event.o dataio.o \
		  misc.o mkstemp.o md5.o lfo.o scan.o control.o far_extras.o \
		  med_extras.o filter.o effects.o flow.o mixer.o mix_all.o rng.o \
		  load_helpers.o load.o hio.o hmn_extras.o extras.o smix.o \
		  filetype.o memio.o tempfile.o mix_paula.o miniz_tinfl.o win32.o

SRC_DFILES	= Makefile $(SRC_OBJS:.o=.c) common.h effects.h \
		  format.h lfo.h list.h mixer.h period.h player.h virtual.h \
		  md5.h precomp_lut.h tempfile.h med_extras.h hio.h rng.h \
		  hmn_extras.h extras.h callbackio.h memio.h mdataio.h \
		  far_extras.h paula.h precomp_blep.h miniz.h

SRC_PATH	= src

OBJS += $(addprefix $(SRC_PATH)/,$(SRC_OBJS))

default-src::
	$(MAKE) -C ..

dist-src::
	mkdir -p $(DIST)/$(SRC_PATH)
	cp -RPp $(addprefix $(SRC_PATH)/,$(SRC_DFILES)) $(DIST)/$(SRC_PATH)

=== test/CMakeLists.txt ===
if(POLICY CMP0079)
    cmake_policy(SET CMP0079 NEW)
endif()

include_directories(
    ${CMAKE_SOURCE_DIR}/include
    ${CMAKE_SOURCE_DIR}/src)

add_executable(libxmp-test test.c ../src/md5.c)
set_property(TARGET libxmp-test PROPERTY C_STANDARD 90)

if(MSVC)
    target_compile_definitions(libxmp-test PRIVATE ${LIBXMP_MSVC_DEFINES})
endif()

if(BUILD_SHARED) # Make sure test.exe will find its dll
    set_property(TARGET libxmp-test PROPERTY RUNTIME_OUTPUT_DIRECTORY ${libxmp_BINARY_DIR})
endif()

target_link_libraries(libxmp-test XMP_IF)

add_test(NAME libxmp-test COMMAND libxmp-test WORKING_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}")
if(LIBXMP_DISABLE_DEPACKERS)
    target_compile_definitions(libxmp-test PRIVATE LIBXMP_NO_DEPACKERS)
endif()

if(BUILD_LITE)
    add_executable(libxmp-lite-test testlite.c ../src/md5.c)
    set_property(TARGET libxmp-lite-test PROPERTY C_STANDARD 90)
    if(MSVC)
        target_compile_definitions(libxmp-lite-test PRIVATE ${LIBXMP_MSVC_DEFINES})
    endif()
    if(BUILD_SHARED) # Make sure test.exe will find its dll
        set_property(TARGET libxmp-lite-test PROPERTY RUNTIME_OUTPUT_DIRECTORY ${libxmp_BINARY_DIR})
    endif()
    target_link_libraries(libxmp-lite-test XMPLITE_IF)
    add_test(NAME libxmp-lite-test COMMAND libxmp-lite-test WORKING_DIRECTORY "${CMAKE_CURRENT_LIST_DIR}")
    target_compile_definitions(libxmp-lite-test PRIVATE LIBXMP_CORE_PLAYER)
    if(LIBXMP_DISABLE_IT)
        target_compile_definitions(libxmp-lite-test PRIVATE LIBXMP_CORE_DISABLE_IT)
    endif()
endif()

=== src/depackers/Makefile ===

DEPACKERS_OBJS	= depacker.o ppdepack.o unsqsh.o mmcmp.o s404_dec.o \
		  arc.o arcfs.o arc_unpack.o lzx.o lzx_unpack.o \
		  miniz_zip.o unzip.o gunzip.o uncompress.o bunzip2.o \
		  unlha.o unxz.o xz_dec_lzma2.o xz_dec_stream.o \
		  crc32.o xfnmatch.o ptpopen.o xfd.o xfd_link.o

DEPACKERS_DFILES = Makefile $(DEPACKERS_OBJS:.o=.c) depacker.h \
		  miniz_zip.h arc_unpack.h lzx_unpack.h \
		  xz_lzma2.h README.unxz xz.h xz_private.h \
		  xz_stream.h xz_config.h crc32.h xfnmatch.h ptpopen.h

DEPACKERS_PATH	= src/depackers

DEPACKER_OBJS	= $(addprefix $(DEPACKERS_PATH)/,$(DEPACKERS_OBJS))

default-depackers::
	$(MAKE) -C ..

dist-depackers::
	mkdir -p $(DIST)/$(DEPACKERS_PATH)
	cp -RPp $(addprefix $(DEPACKERS_PATH)/,$(DEPACKERS_DFILES)) $(DIST)/$(DEPACKERS_PATH)

=== src/lite/Makefile ===

# this _must_ match the libxmp-lite package
LITE		= lite-virtual.o lite-format.o lite-period.o lite-player.o lite-read_event.o \
		  lite-misc.o lite-dataio.o lite-lfo.o lite-scan.o lite-control.o lite-filter.o \
		  lite-effects.o lite-mixer.o lite-mix_all.o lite-load_helpers.o lite-load.o \
		  lite-filetype.o lite-hio.o lite-smix.o lite-memio.o lite-rng.o lite-win32.o \
		  lite-flow.o \
		  \
		  lite-common.o lite-itsex.o lite-sample.o \
		  lite-xm_load.o lite-mod_load.o lite-s3m_load.o lite-it_load.o

LITE_OBJS = $(addprefix $(LITE_PATH)/,$(LITE))
LITE_DFILES	= Makefile README.lite \
		  libxmp-lite-config.cmake libxmp-lite-config.cmake.autotools \
		  libxmp-lite-config-version.cmake.autotools.in libxmp-lite.pc.in \
		  $(LITE:.o=.c)
LITE_PATH	= src/lite

default:

dist-lite::
	mkdir -p $(DIST)/$(LITE_PATH)
	cp -RPp $(addprefix $(LITE_PATH)/,$(LITE_DFILES)) $(DIST)/$(LITE_PATH)

=== src/loaders/Makefile ===

LOADERS	= xm_load.o mod_load.o s3m_load.o stm_load.o 669_load.o far_load.o \
	  mtm_load.o ptm_load.o okt_load.o ult_load.o mdl_load.o it_load.o \
	  stx_load.o pt3_load.o sfx_load.o flt_load.o st_load.o emod_load.o \
	  imf_load.o digi_load.o fnk_load.o ice_load.o liq_load.o ims_load.o \
	  masi_load.o masi16_load.o amf_load.o stim_load.o mmd_common.o \
	  mmd1_load.o mmd3_load.o rtm_load.o dt_load.o no_load.o arch_load.o \
	  sym_load.o med2_load.o med3_load.o med4_load.o dbm_load.o umx_load.o \
	  gdm_load.o pw_load.o gal5_load.o gal4_load.o mfp_load.o asylum_load.o \
	  muse_load.o hmn_load.o mgt_load.o chip_load.o abk_load.o coco_load.o \
	  xmf_load.o

LOADERS_OBJS	= common.o iff.o itsex.o lzw.o voltable.o sample.o vorbis.o \
		  $(LOADERS)

LOADERS_DFILES	= Makefile $(LOADERS_OBJS:.o=.c) \
		  iff.h lzw.h it.h loader.h med.h mod.h s3m.h xm.h vorbis.h
LOADERS_PATH	= src/loaders

OBJS += $(addprefix $(LOADERS_PATH)/,$(LOADERS_OBJS))

default:

dist-loaders::
	mkdir -p $(DIST)/$(LOADERS_PATH)
	cp -RPp $(addprefix $(LOADERS_PATH)/,$(LOADERS_DFILES)) $(DIST)/$(LOADERS_PATH)

=== src/depackers/lhasa/Makefile ===

LHASA_OBJS	= ext_header.o lha_file_header.o lha_input_stream.o \
		  lha_decoder.o lha_reader.o lha_basic_reader.o \
		  lh1_decoder.o lh5_decoder.o lh6_decoder.o lh7_decoder.o \
		  lhx_decoder.o lk7_decoder.o lz5_decoder.o lzs_decoder.o \
		  null_decoder.o pm1_decoder.o pm2_decoder.o macbinary.o

LHASA_DFILES	= Makefile README.lhasa $(LHASA_OBJS:.o=.c) \
		  bit_stream_reader.c lh_new_decoder.c pma_common.c tree_decode.c \
		  ext_header.h lha_basic_reader.h lha_decoder.h lha_file_header.h \
		  lha_input_stream.h macbinary.h  lhasa.h

LHASA_PATH	= src/depackers/lhasa

DEPACKER_OBJS	+= $(addprefix $(LHASA_PATH)/,$(LHASA_OBJS))

default: 

dist-lhasa::
	mkdir -p $(DIST)/$(LHASA_PATH)
	cp -RPp $(addprefix $(LHASA_PATH)/,$(LHASA_DFILES)) $(DIST)/$(LHASA_PATH)

=== src/loaders/prowizard/Makefile ===

PROWIZ_OBJS	= prowiz.o ptktable.o tuning.o ac1d.o di.o eureka.o \
		  fc-m.o fuchs.o fuzzac.o gmc.o heatseek.o ksm.o \
		  mp.o np1.o np2.o np3.o p61a.o pm10c.o pm18a.o \
		  pha.o prun1.o prun2.o tdd.o unic.o unic2.o wn.o zen.o \
		  tp1.o tp3.o p40.o xann.o theplayer.o pp10.o pp21.o \
		  starpack.o titanics.o skyt.o novotrade.o hrt.o noiserun.o
PROWIZ_OBJS2	= pm.o pm01.o pm20.o pm40.o pp30.o
PROWIZ_DFILES	= LICENSE.txt Makefile $(PROWIZ_OBJS:.o=.c) $(PROWIZ_OBJS2:.o=.c) prowiz.h
PROWIZ_PATH	= src/loaders/prowizard

PROWIZARD_OBJS	= $(addprefix $(PROWIZ_PATH)/, $(PROWIZ_OBJS))

dist-prowiz::
	mkdir -p $(DIST)/$(PROWIZ_PATH)
	cp -RPp $(addprefix $(PROWIZ_PATH)/,$(PROWIZ_DFILES)) $(DIST)/$(PROWIZ_PATH)

=== debian/changelog ===
libxmp (4.6.3-1) unstable; urgency=medium

  * New upstream release, merging cve-2025-47256.patch.

 -- Stephen Kitt <skitt@debian.org>  Sat, 23 Aug 2025 20:26:22 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: libs
 Priority: optional
 Maintainer: Stephen Kitt <skitt@debian.org>
-Standards-Version: 4.7.0
+Standards-Version: 4.7.2
 Build-Depends: debhelper-compat (= 13), python3-docutils, rst2pdf
 Homepage: http://xmp.sourceforge.net/
 Vcs-Git: https://salsa.debian.org/mod-player-team/libxmp.git

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_build:
	make V=1 all docs

autoreconf:
	autoreconf -f -i
	cp -f /usr/share/misc/config.guess /usr/share/misc/config.sub ./

override_dh_autoreconf:
	dh_autoreconf debian/rules -- autoreconf

=== debian/watch ===
version=4

http://sf.net/xmp/libxmp-([\d\.]+)\.tar\.gz

## libxmp 4.7.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -1,5 +1,5 @@
-cmake_minimum_required(VERSION 3.4...3.10)
-project(libxmp VERSION 4.6.3 LANGUAGES C)
+cmake_minimum_required(VERSION 3.2...3.10)
+project(libxmp VERSION 4.7.0 LANGUAGES C)
 
 set(LIBXMP_DEFINES)
 set(LIBXMPLITE_DEFINES)
@@ -8,7 +8,6 @@
 include(${CMAKE_CURRENT_SOURCE_DIR}/cmake/libxmp-checks.cmake)
 include(GNUInstallDirs)
 
-# -fPIC thing
 if(NOT WIN32 AND NOT EMSCRIPTEN AND NOT VITA)
     option(LIBXMP_PIC   "Build the static library as position-independent" OFF)
 else()
@@ -95,7 +94,8 @@
     target_compile_definitions(xmp_static PUBLIC LIBXMP_STATIC)
 
     if(LIBXMP_PIC)
-        target_compile_options(xmp_static PRIVATE -fPIC)
+        set_target_properties(xmp_static PROPERTIES
+                    POSITION_INDEPENDENT_CODE TRUE)
     endif()
 
     target_include_directories(xmp_static PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>")
@@ -121,7 +121,8 @@
         target_compile_definitions(xmp_lite_static PUBLIC LIBXMP_STATIC)
 
         if(LIBXMP_PIC)
-            target_compile_options(xmp_lite_static PRIVATE -fPIC)
+            set_target_properties(xmp_lite_static PROPERTIES
+                             POSITION_INDEPENDENT_CODE TRUE)
         endif()
 
         target_include_directories(xmp_lite_static PUBLIC "$<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}/include>")
@@ -300,7 +301,7 @@
 
 include(CMakePackageConfigHelpers)
 
-if(WIN32)
+if(WIN32 AND NOT MINGW)
     set(cmake_install_cmakdir "cmake")
     set(cmake_install_cmakdir_lite "cmake")
 else()
@@ -316,6 +317,3 @@
 configure_file("${CMAKE_CURRENT_SOURCE_DIR}/libxmp.pc.in"
                "${CMAKE_CURRENT_BINARY_DIR}/libxmp.pc" @ONLY
 )
-write_basic_package_version_file(libxmp-config-version.cmake
-    COMPATIBILITY AnyNewerVersion
-)

=== src/Makefile ===

SRC_OBJS	= virtual.o format.o period.o player.o read_event.o dataio.o \
		  misc.o mkstemp.o md5.o lfo.o scan.o control.o far_extras.o \
		  med_extras.o filter.o effects.o flow.o mixer.o mix_all.o rng.o \
		  load_helpers.o load.o hio.o hmn_extras.o extras.o smix.o path.o \
		  filetype.o memio.o tempfile.o mix_paula.o miniz_tinfl.o win32.o

SRC_DFILES	= Makefile $(SRC_OBJS:.o=.c) common.h effects.h \
		  format.h lfo.h mixer.h mix_all.h period.h player.h virtual.h \
		  md5.h precomp_lut.h tempfile.h med_extras.h hio.h rng.h \
		  hmn_extras.h extras.h callbackio.h memio.h mdataio.h \
		  far_extras.h paula.h precomp_blep.h miniz.h path.h

SRC_PATH	= src

OBJS += $(addprefix $(SRC_PATH)/,$(SRC_OBJS))

default-src::
	$(MAKE) -C ..

dist-src::
	mkdir -p $(DIST)/$(SRC_PATH)
	cp -RPp $(addprefix $(SRC_PATH)/,$(SRC_DFILES)) $(DIST)/$(SRC_PATH)

=== src/depackers/Makefile ===
--- 
+++ 
@@ -1,12 +1,14 @@
 
 DEPACKERS_OBJS	= depacker.o ppdepack.o unsqsh.o mmcmp.o s404_dec.o \
 		  arc.o arcfs.o arc_unpack.o lzx.o lzx_unpack.o \
+		  ice.o ice_unpack.o \
 		  miniz_zip.o unzip.o gunzip.o uncompress.o bunzip2.o \
 		  unlha.o unxz.o xz_dec_lzma2.o xz_dec_stream.o \
 		  crc32.o xfnmatch.o ptpopen.o xfd.o xfd_link.o
 
 DEPACKERS_DFILES = Makefile $(DEPACKERS_OBJS:.o=.c) depacker.h \
 		  miniz_zip.h arc_unpack.h lzx_unpack.h \
+		  ice_unpack_fn.c ice_unpack.h \
 		  xz_lzma2.h README.unxz xz.h xz_private.h \
 		  xz_stream.h xz_config.h crc32.h xfnmatch.h ptpopen.h

=== debian/changelog ===
libxmp (4.7.0-1) unstable; urgency=medium

  * New upstream release.
  * Update gbp.conf to track upstream VCS tags.
  * Drop cmake-multiarch-paths.patch, with the switch to CMake the build
    no longer uses libxmp-config.cmake.autotools.

 -- Stephen Kitt <skitt@debian.org>  Thu, 26 Feb 2026 09:02:17 +0100

libxmp (4.6.3-2) unstable; urgency=medium

  * Build the PDF documentation without date information so that it is
    identical across builds.
  * Drop “Rules-Requires-Root: no” since it’s now the default.
  * Drop “Priority: optional” since it’s now the default.
  * Standards-Version 4.7.3, no further change required.
  * Build with CMake; this produces modules that correctly handle /lib
    linked to /usr/lib. Closes: #1117778.

 -- Stephen Kitt <skitt@debian.org>  Tue, 24 Feb 2026 17:53:42 +0100

=== debian/control ===
Source: libxmp
Section: libs
Maintainer: Stephen Kitt <skitt@debian.org>
Standards-Version: 4.7.3
Build-Depends:
 debhelper-compat (= 13),
 cmake,
 ninja-build,
 python3-docutils,
 rst2pdf
Homepage: http://xmp.sourceforge.net/
Vcs-Git: https://salsa.debian.org/mod-player-team/libxmp.git
Vcs-Browser: https://salsa.debian.org/mod-player-team/libxmp

Package: libxmp4
Architecture: any
Multi-Arch: same
Pre-Depends:
 ${misc:Pre-Depends}
Depends:
 ${misc:Depends},
 ${shlibs:Depends}
Description: module file rendering library
 libxmp is a library designed to interpret module files and produce
 PCM audio. It supports over 90 formats including Protracker (MOD),
 Scream Tracker 3 (S3M), Fast Tracker II (XM) and Impulse Tracker
 (IT).

Package: libxmp-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 libxmp4 (= ${binary:Version}),
 ${misc:Depends}
Description: module file rendering library -- development files
 libxmp is a library designed to interpret module files and produce
 PCM audio. It supports over 90 formats including Protracker (MOD),
 Scream Tracker 3 (S3M), Fast Tracker II (XM) and Impulse Tracker
 (IT).
 .
 This package contains the development files required to build with
 libxmp.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@ --buildsystem=cmake+ninja

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_STATIC=OFF -DWITH_UNIT_TESTS=ON
